using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Components.Calendar.MonthCal;
using Components.Calendar.MonthCal.Class;

namespace Components.Calendar.MonthCal.GUI
{
    /// <summary>
    /// For the date selection
    /// </summary>
    public partial class fr_DateSelector : Form
    {
        #region Variables
        /// <summary>
        /// Default vLanguage
        /// </summary>
        private CalendarLanguage vLanguage = new CalendarLanguage();
        /// <summary>
        /// The Selected DateTime
        /// </summary>
        private DateTime vDateToDisplay = DateTime.Today;
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        public fr_DateSelector()
        {
            InitializeComponent();

            cb_Month.DataSource = vLanguage.Months;
        }
        #endregion

        #region Properties
        /// <summary>
        /// Sets the displayed date
        /// </summary>
        public DateTime DateToDisplay
        {
            set
            {
                nud_Year.Value = value.Year;
                cb_Month.SelectedIndex = value.Month - 1;
                this.vDateToDisplay = value;
            }
            get { return this.vDateToDisplay; }
        }
        /// <summary>
        /// Sets the name of the months
        /// </summary>
        public string[] NameOfMonth
        {
            set
            {
                cb_Month.DataSource = null;
                cb_Month.DataSource = value;
            }
        }
        /// <summary>
        /// Sets the language of the menu (Days and Month name)
        /// </summary>
        public CalendarLanguage Language
        {
            set
            {
                vLanguage = value;
                cb_Month.DataSource = null;//Items.Clear();
                cb_Month.DataSource = vLanguage.Months;
            }
        }
        #endregion

        #region Events
        /// <summary>
        /// Click on OK
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_OK(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.OK;
            vDateToDisplay = new DateTime((int)nud_Year.Value, cb_Month.SelectedIndex + 1, 1);
            this.Close();
        }
        /// <summary>
        /// Click on CANCEL
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Cancel(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
            this.Close();
        }
        #endregion
    }
}